#==========================================================================================================================================
# Repository path:    $HeadURL: https://90.145.156.222/DMS-Houtribdijk/code/nc-checks/src/utils/Utils.py $
# Last committed:     $Revision: 531841 $ 
#                     $Author: jansink $
#                     $Date: 2020-02-12 12:02:30 +0100 (wo, 12 feb 2020) $
#
# Copyright © 2019, ®HKV services, All Rights Reserved.
#==========================================================================================================================================

from json import load, JSONDecodeError

class Utils:

    # read the json with the site specification and return it in a dictionary
    @staticmethod
    def read_json(f):
        with open(f) as json_file:
            jsondoc = load(json_file)
        return jsondoc

    # read the json and check for the presence of the expected keys
    @staticmethod
    def read_settings(file, expected_keys):
        try:
            settings = Utils.read_json(file)
        except FileNotFoundError:
            print("ERROR: The file {} could not be found.".format(file))
            exit(1)
        except JSONDecodeError:
            print("ERROR: The file {} is not a valid json file.".format(file))
            exit(1)
        else:
            # test presence expected keys
            for k in expected_keys:
                try:
                    dummy = settings[k]
                except KeyError:
                    print(
                        "ERROR: Expected key {} is not found in file {}.".format(
                            k, file
                        )
                    )
                    exit(1)
            return settings

    @staticmethod   
    def read_monitor_checks_settings(settings_file):
        expected_keys = [
            "thredds_data",
            "hkvservices",
            "user_id",
            "prtg_out",
            "checks_abs",
            "checks_dif",
            "database",
            "log_folder",
            "logger",
            "logfile"            
        ]
        return Utils.read_settings(settings_file, expected_keys)
